Index: libabac/abac_pl_yy.c
===================================================================
--- libabac/abac_pl_yy.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_pl_yy.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -435,32 +611,632 @@
               name=abac_xstrdup(ptr->cn);
               cond=NULL;
+              ptr=NULL;
               break;
            }
-           case DTERM_ANONYMOUS:
+           case e_yy_DTERM_ANONYMOUS:
            {
               type=0;
               name=abac_xstrdup("_");
               cond=NULL;
+              ptr=NULL;
               break;
            }
        }
+
+       abac_term_t *param=abac_term_new(type,name,cond,ptr);
        if (linked) 
-           abac_role_role_add_linked_param(role, type, name, cond);
+           abac_oset_oset_add_linked_param(oset, param);
            else
-                abac_role_role_add_param(role, type, name, cond);
+                abac_oset_oset_add_param(oset, param);
        curr=curr->next;
    }
 }
 
-static void _role_add_linked_dterms(abac_role_t *role, abac_yy_dterm_t *dterms)
+static void _oset_add_linked_terms(abac_oset_t *oset, abac_yy_term_t *terms)
 {
     int linked=1;
-    _role_add_dterms(linked, role, dterms);
-}
-
-static void _role_add_role_dterms(abac_role_t *role, abac_yy_dterm_t *dterms)
+    _oset_add_terms(linked, oset, terms);
+}
+
+static void _oset_add_oset_terms(abac_oset_t *oset, abac_yy_term_t *terms)
 {
     int linked=0;
-    _role_add_dterms(linked, role, dterms);
+    _oset_add_terms(linked, oset, terms);
+}
+
+
+abac_oset_t *validate_intersected_tail_oset(abac_oset_t *oset)
+{
+    abac_oset_t *ret_oset=NULL;
+    abac_list_t *prereqs = abac_list_new();
+    abac_list_add(prereqs, oset);
+    ret_oset = abac_oset_intersection_new("intersectingOSET", prereqs);
+    return ret_oset;
+}
+
+/* A.oset */
+abac_oset_t *validate_head_oset(abac_yy_expression_t *expr)
+{
+     abac_yy_principal_t *principal=expr->principal;
+     abac_yy_oset_t *oset=expr->oset;
+    
+     char *principalname=get_yy_principal_principalname(principal);
+     char *osetname=oset->name;
+     abac_yy_term_t *terms=oset->terms;
+
+     abac_oset_t *ret_oset=abac_oset_oset_new(principalname, osetname);
+     if (ret_oset==NULL) {
+         set_error_code(ABAC_RT_ROLE_INVALID);
+         goto error;
+     }
+     if (!abac_oset_is_oset(ret_oset)) {
+         set_error_code(ABAC_RT_CERT_INVALID);
+         goto error;
+     }
+     // insert the params for the oset
+     if(terms) {
+          _oset_add_oset_terms(ret_oset, terms);
+     }
+     _add_yy_id_certs(principal->cn,principal->type);
+
+     return ret_oset;
+
+error:
+     return NULL;
+}
+
+/* B */
+abac_oset_t *validate_named_tail_oset(abac_yy_expression_t *expr)
+{
+     abac_yy_principal_t *principal=expr->principal;
+     char *principalname=principal->sha;
+     abac_oset_t *ret_oset=NULL;
+
+     ret_oset = abac_oset_principal_new(principalname);
+
+     _add_yy_id_certs(principal->cn,principal->type);
+
+     if (ret_oset==NULL)
+         goto error;
+     return ret_oset;
+
+error:
+     panic("can not generate a simple named tail oset");
+     return NULL;
+}
+
+
+/* [keyid:alpha].oset:documents([string:'proj1'])<-[urn:'file//fileA'] */
+abac_oset_t *validate_object_tail_oset(abac_yy_expression_t *expr)
+{
+     abac_yy_term_data_t *object=get_yy_expression_object(expr);
+     assert(object != NULL);
+
+     char *name=object->name;
+     int type=object->type;
+     char *cond=object->condition;
+     void *ptr=object->cptr;
+     abac_term_t *term=abac_term_new(type,name,cond,ptr);
+     abac_oset_t *ret_oset=abac_oset_object_new(term);
+
+     if(get_yy_term_data_is_variable(object))
+         _add_yy_id_certs(name,type);
+
+     if (ret_oset==NULL)
+         goto error;
+     return ret_oset;
+
+error:
+     panic("can not generate a simple object tail oset");
+     return NULL;
+}
+
+
+/* B.oset */
+abac_oset_t *validate_oset_tail_oset(abac_yy_expression_t *expr)
+{
+     abac_yy_principal_t *principal=expr->principal;
+     abac_yy_oset_t *oset=expr->oset;
+
+     char *principalname=principal->sha;
+
+     char *osetname=oset->name;
+     abac_yy_term_t *terms=oset->terms;
+
+     int ret;
+     abac_oset_t *ret_oset=NULL;
+
+     ret_oset = abac_oset_oset_new(principalname, osetname);
+     if (ret_oset==NULL)
+         goto error;
+
+     if(terms) {
+         _oset_add_oset_terms(ret_oset, terms);
+     }
+
+     _add_yy_id_certs(principal->cn,principal->type);
+
+     return ret_oset;
+
+error:
+     panic("can not generate a simple tail oset");
+     return NULL;
+}
+
+/* B.role.oset */
+abac_oset_t *validate_linked_tail_oset(abac_yy_expression_t *expr)
+{
+     abac_yy_principal_t *principal=expr->principal;
+     abac_yy_oset_t *oset=expr->oset;
+     abac_yy_role_t *linked_role=expr->linked_role;
+
+     char *principalname=principal->sha;
+
+     char *osetname=oset->name;
+     abac_yy_term_t *terms=oset->terms;
+
+     char *linkedrolename=linked_role->name;
+     abac_yy_term_t *linked_terms=linked_role->terms;
+
+     int ret;
+     abac_oset_t *ret_oset=abac_oset_linking_new(principalname,
+                                            linkedrolename, osetname);
+     if (ret_oset==NULL)
+         goto error;
+
+     if(linked_terms) {
+         _oset_add_linked_terms(ret_oset, linked_terms);
+     }
+     if(terms) {
+         _oset_add_oset_terms(ret_oset, terms);
+     }
+
+     _add_yy_id_certs(principal->cn,principal->type);
+
+     return ret_oset;
+
+error:
+     panic("can not generate linked tail oset");
+     return NULL;
+}
+
+
+
+abac_list_t *make_oset_statement(abac_yy_expression_t *headexpr,
+                       abac_yy_expression_t *tailexpr) 
+{ 
+    abac_oset_t *head_oset=NULL;
+    abac_oset_t *tail_oset=NULL;
+
+/* build up left side's abac oset structure */
+    head_oset=validate_head_oset(headexpr);
+    if(head_oset == NULL)
+        goto error;
+
+/* build up the right side's abac oset structure */
+    abac_yy_expression_t *curr_tail = tailexpr;
+    int intersecting=(tailexpr->next != NULL)? 1:0;
+    abac_oset_t *curr_oset = NULL;
+        while (curr_tail) {
+            switch(curr_tail->type) {
+                case e_yy_EXPR_OBJECT:
+                    curr_oset=validate_object_tail_oset(curr_tail);
+                    break;
+                case e_yy_EXPR_NAMED:
+                    curr_oset=validate_named_tail_oset(curr_tail);
+                    break;
+                case e_yy_EXPR_OSET:
+                    curr_oset=validate_oset_tail_oset(curr_tail);
+                    break;
+                case e_yy_EXPR_LINKED:
+                    curr_oset=validate_linked_tail_oset(curr_tail);
+                    break;
+            }
+            if(curr_oset==NULL)
+                goto error;
+
+            /* check if first one */
+            if(tail_oset==NULL) {
+                if(intersecting) 
+                    tail_oset=validate_intersected_tail_oset(curr_oset);
+                    else 
+                        tail_oset=curr_oset;
+                } else {  
+                    abac_oset_add_intersecting_oset(tail_oset,curr_oset);
+            }
+            curr_tail=curr_tail->next;
+        } /* while */
+
+/* XXX collect up type clauses, constraint clauses and 
+   generate rule clauses */
+        abac_list_t *tmp=generate_pl_oset_clauses(head_oset,tail_oset);
+        if(tmp == NULL)
+            goto error;
+
+        if(debug) {
+            abac_print_oset_string_with_condition(head_oset,NULL);
+            abac_print_oset_string_with_condition(tail_oset,NULL);
+        }
+
+        _free_yy_expression(headexpr);
+        _free_yy_expression(tailexpr);
+        abac_yap_head_oset=head_oset;
+        abac_yap_tail_oset=tail_oset;
+        abac_yap_is_oset=1;
+        return tmp;
+
+error:
+        _free_yy_expression(headexpr);
+        _free_yy_expression(tailexpr);
+        if(head_oset)
+            abac_oset_free(head_oset);
+        if(tail_oset)
+            abac_oset_free(tail_oset);
+        return NULL;
+}
+
+/***********************************************************************/
+/*
+struct _abac_yy_term_data_t {
+    int is_variable;
+    int type;
+    char *name;
+    char *condition;
+    void *cptr; // ptr to a saved abac_oset_t
+    abac_list_t *cond_range;
+    abac_yy_expression_t *cond_head_expr;
+};
+*/
+
+abac_yy_term_data_t *make_yy_term_data(char* name)
+{
+    abac_yy_term_data_t *ptr=
+              (abac_yy_term_data_t*)abac_xmalloc(sizeof(abac_yy_term_data_t));
+    ptr->name=abac_xstrdup(name);
+    ptr->type=0;
+    ptr->is_variable=0;
+    ptr->condition=NULL;
+    ptr->cond_head_expr=NULL;
+    ptr->cptr=NULL;
+    ptr->cond_range=NULL;
+    return ptr;
+}
+
+abac_list_t *get_yy_term_data_cond_range(abac_yy_term_data_t *ptr)
+{
+    return ptr->cond_range;
+}
+
+char *get_yy_term_data_name(abac_yy_term_data_t *ptr)
+{
+    return ptr->name;
+}
+
+int is_yy_term_data_has_constraint(abac_yy_term_data_t *ptr)
+{
+    if(ptr->cond_head_expr != NULL)
+        return 1;
+/* only select few */
+    if( ptr->cond_range != NULL && abac_term_is_integer_type(ptr->type))
+        return 1;
+    return 0;
+}
+
+void set_yy_term_data_cond_range(abac_yy_term_data_t *ptr,
+abac_list_t *range)
+{
+    ptr->cond_range=range;
+}
+
+void set_yy_term_data_cond_head_expr(abac_yy_term_data_t *ptr,
+abac_yy_expression_t *expr)
+{
+    ptr->cond_head_expr=expr;
+}
+
+abac_yy_expression_t *get_yy_term_data_cond_head_expr(abac_yy_term_data_t *ptr)
+{
+    return ptr->cond_head_expr;
+}
+
+void set_yy_term_data_type(abac_yy_term_data_t *ptr, char* typestr)
+{
+    int type=abac_verify_term_type(typestr);
+    ptr->type=type;
+}
+
+void set_yy_term_data_cptr(abac_yy_term_data_t *ptr, void *vptr)
+{
+    ptr->cptr=vptr;
+}
+
+void set_yy_term_data_condition(abac_yy_term_data_t *ptr, char *cond)
+{
+    ptr->condition=strdup(cond);
+}
+
+void set_yy_term_data_is_variable(abac_yy_term_data_t *ptr)
+{
+    ptr->is_variable=1;
+}
+
+int get_yy_term_data_is_variable(abac_yy_term_data_t *ptr)
+{
+    return ptr->is_variable;
+}
+
+static void _free_yy_term_data(abac_yy_term_data_t *ptr)
+{
+    free(ptr->name);
+    if(ptr->condition)
+        free(ptr->condition);
+    if(ptr->cond_head_expr)
+        _free_yy_expression(ptr->cond_head_expr);
+    if(ptr->cond_range);
+        _free_yy_range(ptr->cond_range);
+    free(ptr);
+}
+
+abac_yy_term_principal_t *make_yy_term_principal(char* name)
+{
+    abac_yy_term_principal_t *ptr=
+            (abac_yy_term_principal_t*)abac_xmalloc(sizeof(abac_yy_term_principal_t));
+    ptr->name=abac_xstrdup(name);
+    ptr->condition=NULL;
+    ptr->cond_head_expr=NULL;
+    return ptr;
+}
+
+void set_yy_term_principal_cptr(abac_yy_term_principal_t *ptr, void *vptr)
+{
+    ptr->cptr=vptr;
+}
+
+void set_yy_term_principal_condition(abac_yy_term_principal_t *ptr, char *cond)
+{
+    ptr->condition=abac_xstrdup(cond);
+}
+
+abac_yy_expression_t *get_yy_term_principal_cond_head_expr(abac_yy_term_principal_t *ptr)
+{
+    return ptr->cond_head_expr;
+}
+
+void set_yy_term_principal_cond_head_expr(abac_yy_term_principal_t *ptr, 
+abac_yy_expression_t *expr)
+{
+    ptr->cond_head_expr=expr;
+}
+
+static void _free_yy_term_principal(abac_yy_term_principal_t *ptr)
+{
+    free(ptr->name);
+    if(ptr->condition)
+        free(ptr->condition);
+    if(ptr->cond_head_expr)
+        _free_yy_expression(ptr->cond_head_expr);
+    free(ptr);
+}
+
+abac_yy_term_t *make_yy_term_dterm_anonymous()
+{
+    abac_yy_term_t *ptr=(abac_yy_term_t*)abac_xmalloc(sizeof(abac_yy_term_t));
+    ptr->type = e_yy_DTERM_ANONYMOUS;
+    ptr->next=NULL;
+    ptr->bcnt=1;
+    return ptr;
+}
+
+abac_yy_term_t *make_yy_term_dterm_principal(abac_yy_term_principal_t *pptr)
+{
+    abac_yy_term_t *ptr=(abac_yy_term_t*)abac_xmalloc(sizeof(abac_yy_term_t));
+    ptr->type = e_yy_DTERM_PRINCIPAL;
+    ptr->term.p_ptr=pptr;
+    ptr->next=NULL;
+    ptr->bcnt=1;
+    return ptr;
+}
+
+abac_yy_term_t *make_yy_term_dterm_named(abac_yy_principal_t *nptr)
+{
+    abac_yy_term_t *ptr=(abac_yy_term_t*)abac_xmalloc(sizeof(abac_yy_term_t));
+    ptr->type = e_yy_DTERM_NAMED;
+    ptr->term.n_ptr=nptr;
+    ptr->next=NULL;
+    ptr->bcnt=1;
+    return ptr;
+}
+
+abac_yy_term_t *make_yy_term_dterm_data(abac_yy_term_data_t *dptr)
+{
+    abac_yy_term_t *ptr=(abac_yy_term_t*)abac_xmalloc(sizeof(abac_yy_term_t));
+    ptr->type = e_yy_DTERM_DATA;
+    ptr->term.d_ptr=dptr;
+    ptr->next=NULL;
+    ptr->bcnt=1;
+    return ptr;
+}
+
+abac_yy_term_t *add_yy_term(abac_yy_term_t *nterm, abac_yy_term_t *terms)
+{
+    int i=terms->bcnt;
+    nterm->next=terms;
+    nterm->bcnt=i+1;
+    return nterm;
+}
+
+static void _free_yy_term(abac_yy_term_t *ptr)
+{
+    switch (ptr->type) {
+        case e_yy_DTERM_DATA:
+            _free_yy_term_data(ptr->term.d_ptr);
+            break;
+        case e_yy_DTERM_NAMED:
+            _free_yy_principal(ptr->term.n_ptr);
+            break;
+        case e_yy_DTERM_PRINCIPAL:
+            _free_yy_term_principal(ptr->term.p_ptr);
+            break;
+        case e_yy_DTERM_ANONYMOUS:
+            break;
+    }
+    if(ptr->next)
+        _free_yy_term(ptr->next);
+    free(ptr);
+}
+
+/****************************************************************/
+/* add the condition to constraint list */
+char *make_yy_oset_constraint(abac_yy_term_data_t *ptr, char *tail_string)
+{
+   abac_yy_expression_t *head_expr=get_yy_term_data_cond_head_expr(ptr);
+   if(head_expr) {
+       abac_oset_t *head_oset=validate_head_oset(head_expr);
+       if(head_oset == NULL)
+           goto error;
+
+       char *tmp=generate_pl_oset_constraint_clause(head_oset,tail_string);
+       set_yy_term_data_condition(ptr,tmp);
+       set_yy_term_data_cptr(ptr,head_oset);
+       abac_add_yy_constraints(tmp);
+       return tmp;
+   }
+   return NULL;
+error:
+   return NULL;
+} 
+/****************************************************************/
+/* add the range condition to constraint list */
+
+void make_yy_range_constraint(abac_yy_term_data_t *ptr, char *var)
+{
+   char *typestr=abac_term_type(ptr->type);
+   abac_list_t *rlist=get_yy_term_data_cond_range(ptr);
+   char *tmplist=NULL;
+   char *tmp=NULL;
+   int is_range=1; /* either , or | */
+   if(rlist) {
+       char *rstring=string_yy_cond_range(rlist);
+       set_yy_term_data_condition(ptr,rstring);
+       abac_yy_range_t *cur;
+     
+       abac_list_foreach(rlist, cur,
+           int type=cur->type;
+           char *val=cur->val; 
+           switch(type) {
+             case e_yy_RANGE_MIN:
+               tmp=generate_pl_range_constraint_clause(typestr,var,val,">");
+               break;
+             case e_yy_RANGE_MAX:
+               tmp=generate_pl_range_constraint_clause(typestr,var,val,"<");
+               break;
+             case e_yy_RANGE_TARGET:
+               tmp=generate_pl_range_constraint_clause(typestr,var,val,"=");
+               int is_range=0;
+               break;
+           }
+           if(tmplist) {
+               if(is_range)
+                   asprintf(&tmplist,"%s,%s",tmplist,tmp);
+                   else
+                       asprintf(&tmplist,"%s;%s",tmplist,tmp);
+               } else {
+                   tmplist=tmp;
+           }
+           tmp=NULL;
+       );
+       asprintf(&tmplist,"(%s)",tmplist);
+       abac_add_yy_constraints(tmplist);
+   }
+}
+
+char *make_yy_role_constraint(abac_yy_term_principal_t *ptr, char *tail_string)
+{
+   char *tmp=NULL;
+   abac_role_t *head_role=NULL;
+
+   abac_yy_expression_t *head_expr=get_yy_term_principal_cond_head_expr(ptr);
+/* build up left side's abac role constraint structure */
+   head_role=validate_head_role(head_expr);
+   if(head_role == NULL)
+       goto error;
+
+   tmp=generate_pl_role_constraint_clause(head_role,tail_string);
+   set_yy_term_principal_condition(ptr,tmp);
+   set_yy_term_principal_cptr(ptr,head_role);
+   abac_add_yy_constraints(tmp);
+   return tmp;
+
+error:
+   return NULL;
+}
+
+/****************************************************************/
+static void _role_add_terms(int linked, abac_role_t *role, 
+abac_yy_term_t *terms)
+{
+    abac_yy_term_t *curr = terms;
+    int type;
+    char *name=NULL;
+    char *cond=NULL;
+    void *ptr=NULL;
+    while (curr) {
+        switch (curr->type) {
+           case e_yy_DTERM_DATA:
+           {
+               abac_yy_term_data_t *ptr=curr->term.d_ptr;
+               type=ptr->type;
+               name=abac_xstrdup(ptr->name);
+               cond=abac_xstrdup(ptr->condition);
+               ptr=ptr->cptr;
+               break;
+           }
+           case e_yy_DTERM_PRINCIPAL:
+           {
+              abac_yy_term_principal_t *ptr=curr->term.p_ptr;
+              type=abac_verify_term_type("principal");
+              name=abac_xstrdup(ptr->name);
+              cond=abac_xstrdup(ptr->condition);
+              ptr=ptr->cptr;
+              break;
+           }
+           case e_yy_DTERM_NAMED:
+           {
+              abac_yy_principal_t *ptr=curr->term.n_ptr;
+              type=ptr->type;
+/* XXX should be switching to sha in the future */
+              name=abac_xstrdup(ptr->cn);
+              cond=NULL;
+              ptr=NULL;
+              break;
+           }
+           case e_yy_DTERM_ANONYMOUS:
+           {
+              type=0;
+              name=abac_xstrdup("_");
+              cond=NULL;
+              ptr=NULL;
+              break;
+           }
+       }
+       abac_term_t *param=abac_term_new(type,name,cond,ptr);
+       if (linked) 
+           abac_role_role_add_linked_param(role, param);
+           else
+                abac_role_role_add_param(role, param);
+       curr=curr->next;
+   }
+}
+
+static void _role_add_linked_terms(abac_role_t *role, abac_yy_term_t *terms)
+{
+    int linked=1;
+    _role_add_terms(linked, role, terms);
+}
+
+static void _role_add_role_terms(abac_role_t *role, abac_yy_term_t *terms)
+{
+    int linked=0;
+    _role_add_terms(linked, role, terms);
 }
 
@@ -475,12 +1251,12 @@
 }
 
-abac_role_t *validate_head_role(abac_yy_role_expression_t *expr)
+abac_role_t *validate_head_role(abac_yy_expression_t *expr)
 {
      abac_yy_principal_t *principal=expr->principal;
      abac_yy_role_t *role=expr->role;
 
-     char *principalname=principal->sha;
+     char *principalname=get_yy_principal_principalname(principal);
      char *rolename=role->name;
-     abac_yy_dterm_t *dterms=role->dterms;
+     abac_yy_term_t *terms=role->terms;
      abac_role_t *ret_role=NULL;
 
@@ -495,6 +1271,6 @@
      }
      // insert the params for the role
-     if(dterms) {
-          _role_add_role_dterms(ret_role, dterms);
+     if(terms) {
+          _role_add_role_terms(ret_role, terms);
      }
 
@@ -507,12 +1283,11 @@
 }
 
-abac_role_t *validate_named_tail_role(abac_yy_role_expression_t *expr)
+abac_role_t *validate_named_tail_role(abac_yy_expression_t *expr)
 {
      abac_yy_principal_t *principal=expr->principal;
-     char *principalname=principal->sha;
+     char *principalname=get_yy_principal_principalname(principal);
      abac_role_t *ret_role=NULL;
 
      ret_role = abac_role_principal_new(principalname);
-
      _add_yy_id_certs(principal->cn,principal->type);
 
@@ -526,13 +1301,13 @@
 }
 
-abac_role_t *validate_role_tail_role(abac_yy_role_expression_t *expr)
+abac_role_t *validate_role_tail_role(abac_yy_expression_t *expr)
 {
      abac_yy_principal_t *principal=expr->principal;
      abac_yy_role_t *role=expr->role;
 
-     char *principalname=principal->sha;
+     char *principalname=get_yy_principal_principalname(principal);
 
      char *rolename=role->name;
-     abac_yy_dterm_t *dterms=role->dterms;
+     abac_yy_term_t *terms=role->terms;
 
      int ret;
@@ -543,6 +1318,6 @@
          goto error;
 
-     if(dterms) {
-         _role_add_role_dterms(ret_role, dterms);
+     if(terms) {
+         _role_add_role_terms(ret_role, terms);
      }
 
@@ -556,5 +1331,5 @@
 }
 /* need to validate/generate a linked role out of this */
-abac_role_t *validate_linked_tail_role(abac_yy_role_expression_t *expr)
+abac_role_t *validate_linked_tail_role(abac_yy_expression_t *expr)
 {
      abac_yy_principal_t *principal=expr->principal;
@@ -562,11 +1337,11 @@
      abac_yy_role_t *linked_role=expr->linked_role;
 
-     char *principalname=principal->sha;
+     char *principalname=get_yy_principal_principalname(principal);
 
      char *rolename=role->name;
-     abac_yy_dterm_t *dterms=role->dterms;
+     abac_yy_term_t *terms=role->terms;
 
      char *linkedrolename=linked_role->name;
-     abac_yy_dterm_t *linked_dterms=linked_role->dterms;
+     abac_yy_term_t *linked_terms=linked_role->terms;
 
      int ret;
@@ -577,9 +1352,9 @@
          goto error;
 
-     if(linked_dterms) {
-         _role_add_linked_dterms(ret_role, linked_dterms);
+     if(linked_terms) {
+         _role_add_linked_terms(ret_role, linked_terms);
      }
-     if(dterms) {
-         _role_add_role_dterms(ret_role, dterms);
+     if(terms) {
+         _role_add_role_terms(ret_role, terms);
      }
 
@@ -594,6 +1369,8 @@
 
 
-abac_list_t *make_statement(abac_yy_role_expression_t *headexpr,
-                       abac_yy_role_expression_t *tailexpr) 
+/* build up the abac structure and also create the yap clause
+   and insert it into db */
+abac_list_t *make_role_statement(abac_yy_expression_t *headexpr,
+abac_yy_expression_t *tailexpr) 
 { 
     abac_role_t *head_role=NULL;
@@ -606,16 +1383,16 @@
 
 /* build up the right side's abac role structure */
-    abac_yy_role_expression_t *curr_tail = tailexpr;
+    abac_yy_expression_t *curr_tail = tailexpr;
     int intersecting=(tailexpr->next != NULL)? 1:0;
     abac_role_t *curr_role = NULL;
         while (curr_tail) {
-            switch(curr_tail->rtype) {
-                case EXPR_NAMED:
+            switch(curr_tail->type) {
+                case e_yy_EXPR_NAMED:
                     curr_role=validate_named_tail_role(curr_tail);
                     break;
-                case EXPR_ROLE:
+                case e_yy_EXPR_ROLE:
                     curr_role=validate_role_tail_role(curr_tail);
                     break;
-                case EXPR_LINKED:
+                case e_yy_EXPR_LINKED:
                     curr_role=validate_linked_tail_role(curr_tail);
                     break;
@@ -636,23 +1413,25 @@
         } /* while */
 
-/* collect up type clauses and generate rule clauses */
-        abac_list_t *tmp=generate_pl_clauses(head_role,tail_role);
+/* collect up type clauses, constraint clases and 
+   generate the final rule clauses */
+        abac_list_t *tmp=generate_pl_role_clauses(head_role,tail_role);
         if(tmp == NULL)
             goto error;
 
         if(debug) {
-            abac_print_role_string_with_condition(head_role);
-            abac_print_role_string_with_condition(tail_role);
+            abac_print_role_string_with_condition(head_role,NULL);
+            abac_print_role_string_with_condition(tail_role,NULL);
         }
 
-        _free_yy_role_expression(headexpr);
-        _free_yy_role_expression(tailexpr);
+        _free_yy_expression(headexpr);
+        _free_yy_expression(tailexpr);
         abac_yap_head_role=head_role;
         abac_yap_tail_role=tail_role;
+        abac_yap_is_oset=0;
         return tmp;
 
 error:
-        _free_yy_role_expression(headexpr);
-        _free_yy_role_expression(tailexpr);
+        _free_yy_expression(headexpr);
+        _free_yy_expression(tailexpr);
         if(head_role)
             abac_role_free(head_role);
@@ -661,2 +1440,4 @@
         return NULL;
 }
+
+
Index: libabac/abac_pl_yy.h
===================================================================
--- libabac/abac_pl_yy.h	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_pl_yy.h	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -9,21 +9,30 @@
 
 typedef struct _abac_yy_principal_t abac_yy_principal_t;
-typedef struct _abac_yy_param_principal_t abac_yy_param_principal_t;
-typedef struct _abac_yy_param_data_t abac_yy_param_data_t;
-typedef struct _abac_yy_dterm_t abac_yy_dterm_t;
+typedef struct _abac_yy_term_principal_t abac_yy_term_principal_t;
+typedef struct _abac_yy_term_data_t abac_yy_term_data_t;
+typedef struct _abac_yy_term_t abac_yy_term_t;
 typedef struct _abac_yy_role_t abac_yy_role_t;
-typedef struct _abac_yy_role_expression_t abac_yy_role_expression_t;
+typedef struct _abac_yy_oset_t abac_yy_oset_t;
+typedef struct _abac_yy_expression_t abac_yy_expression_t;
 
 enum expr_rtype {
-    EXPR_NAMED=1,
-    EXPR_ROLE=2,
-    EXPR_LINKED=3
+    e_yy_EXPR_NAMED=1,
+    e_yy_EXPR_ROLE=2,
+    e_yy_EXPR_OSET=3,
+    e_yy_EXPR_LINKED=4,
+    e_yy_EXPR_OBJECT=5
 };
 
 enum dterm_type {
-    DTERM_PRINCIPAL=1,
-    DTERM_NAMED=2,
-    DTERM_DATA=3,
-    DTERM_ANONYMOUS=4
+    e_yy_DTERM_PRINCIPAL=1,
+    e_yy_DTERM_NAMED=2,
+    e_yy_DTERM_DATA=3,
+    e_yy_DTERM_ANONYMOUS=4
+};
+
+enum range_type {
+   e_yy_RANGE_MIN=1,
+   e_yy_RANGE_MAX=2,
+   e_yy_RANGE_TARGET=3 
 };
 
Index: libabac/abac_role.c
===================================================================
--- libabac/abac_role.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_role.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -193,10 +193,10 @@
         return;
 
-    free(role->principal_name);
-    free(role->linked_role_name);
-    free(role->role_name);
-
-    free(role->string);
-    free(role->linked);
+    if(role->principal_name) free(role->principal_name);
+    if(role->linked_role_name) free(role->linked_role_name);
+    if(role->role_name) free(role->role_name);
+
+    if(role->string) free(role->string);
+    if(role->linked) free(role->linked);
 
     if (role->role_params != NULL) {
@@ -219,11 +219,10 @@
 }
 
-abac_role_t *abac_role_role_add_param(abac_role_t *role, int type, char *name, char *cond)
+abac_role_t *abac_role_role_add_param(abac_role_t *role, abac_term_t *param)
 {
-     abac_param_t *param=abac_param_new(type,name,cond);
      if(role->role_params == NULL) {
         role->role_params=abac_param_list_new(param);
         } else {
-            abac_param_list_add_param(role->role_params, param);
+            abac_param_list_add_term(role->role_params, param);
      }
      return role;
@@ -236,11 +235,10 @@
 }
 
-abac_role_t *abac_role_role_add_linked_param(abac_role_t *role, int type, char *name, char *cond)
+abac_role_t *abac_role_role_add_linked_param(abac_role_t *role, abac_term_t *param)
 {
-     abac_param_t *param=abac_param_new(type,name,cond);
      if(role->linked_role_params == NULL) {
         role->linked_role_params=abac_param_list_new(param);
         } else {
-            abac_param_list_add_param(role->linked_role_params, param);
+            abac_param_list_add_term(role->linked_role_params, param);
      }
      return role;
@@ -486,8 +484,10 @@
 }
 
-void abac_print_role_string_with_condition(abac_role_t *role)
+void abac_print_role_string_with_condition(abac_role_t *role,FILE *fp)
 {
     char *string=abac_role_string_with_condition(role);
-    printf("%s",string);
+    if(fp==NULL)
+        printf("%s",string);
+        else fprintf(fp,"%s",string);
 }
 
@@ -499,4 +499,12 @@
     assert(role != NULL);
     return role->role_name;
+}
+
+char *abac_role_role_param_string(abac_role_t *role) {
+    assert(role != NULL);
+    if(role->role_params) {
+         return abac_param_list_string(role->role_params);
+    }
+    return NULL;
 }
 
Index: libabac/abac_rt.h
===================================================================
--- libabac/abac_rt.h	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_rt.h	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -21,4 +21,5 @@
 extern void abac_reset_yyfptr(char *);
 extern char* abac_get_yyfptr();
+extern char* abac_get_yyfptr_encoded();
 
 /* on error code */
Index: libabac/abac_stack.c
===================================================================
--- libabac/abac_stack.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_stack.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -9,4 +9,16 @@
     ret->size = 0;
     return ret;
+}
+
+/* push only if it is not in there still */
+void abac_stack_unique_push(abac_stack_t *stack, void *elt) {
+    if(!stack) return; 
+
+    void *cur;
+    abac_stack_foreach(stack, cur,
+        if(cur == elt)
+            return;
+        );
+    abac_stack_push(stack,elt);
 }
 
@@ -22,4 +34,6 @@
     abac_stack_element_t *cur;
     void *ret;
+   
+    if(!stack) return NULL;
 
     if(stack->size>0) {
@@ -36,9 +50,12 @@
 
 int abac_stack_size(abac_stack_t *stack) {
-    return stack->size;
+    if(stack) return stack->size;
+    return 0;
 }
 
 void abac_stack_free(abac_stack_t *stack) {
     abac_stack_element_t *elt, *tmp;
+
+    if(!stack) return; 
 
     // free everthing in the stack
Index: libabac/abac_stack.h
===================================================================
--- libabac/abac_stack.h	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_stack.h	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -19,4 +19,5 @@
 abac_stack_t *abac_stack_new(void);
 void abac_stack_push(abac_stack_t *stack, void *elt);
+void abac_stack_unique_push(abac_stack_t *stack, void *elt);
 void *abac_stack_pop(abac_stack_t *stack);
 int abac_stack_size(abac_stack_t *stack);
